
#ifndef MyRunAction_h
#define MyRunAction_h 1

#include "G4UserRunAction.hh"
#include "G4String.hh"

//G4AnalysisMananager
#include "MyAnalysis.hh"

class MyRun;
class G4Timer;


class MyRunAction: public G4UserRunAction {

public:

  MyRunAction(bool isGeantino, bool isStepStats, G4String geantinoMapsFileName="geantinoMaps.root", G4String stepStatsFilename="stepStats.root");
  virtual ~MyRunAction();

  virtual G4Run* GenerateRun();
  virtual void BeginOfRunAction(const G4Run* aRun);
  virtual void EndOfRunAction(const G4Run* aRun);

  void SetPerformanceFlag(G4bool val) { fIsPerformance=val;   }
  bool getIsStepStats() { return fIsStepStats; }

private:
  G4bool       fIsPerformance;
  G4bool       fIsGeantino;
  G4bool       fIsStepStats;
  MyRun*       fRun;
  G4Timer*     fTimer;
  G4String     fGeantinoMapsFilename;
  G4String     fStepStatsFilename;
  

    //TO DO: make private and add Get methods
public:
    
    static G4AnalysisManager* fMasterAnalysisManager;
    // ID of the RadLen 2D Profile
    int fRadName_id;
    // ID of the IntLen 2D Profile
    int fIntName_id;
    // ID of the Eta RadLen 1D Profile
    int fEtaRad_id;
    // ID of the Eta IntLen 1D Profile
    int fEtaInt_id;
    // ID of the ZRSteps 2D Histogram
    int fStepHeatMap_id;
    // ID of the ESteps 1D Histogram
    int fStepKinetic_id;
    // ID of the LSteps 1D Histogram
    int fStepLength_id;
    // ID of the LStepsIn 1D Histogram
    int fStepLengthIn_id;
    // ID of the LSteps 1D Histogram
    int fStepLengthOut_id;
    // ID of the InitETracks 1D Histogram
    int fInitTrackKinetic_id;
    // ID of the NumOfSteps 1D Histogram
    int fNumOfSteps_id;
    // ID of the numOfStepsPerInitE 1D Histogram
    int fNumOfStepsPerInitE_id;
    // ID of the numOfBoundXings 1D Histogram
    int fNumOfBoundXings_id;

};

#endif
